package arquivo

import (
	"bufio"
	"os"
	"strings"
	"log"
	//"fmt"
	"github.com/mscastanho/padariaOak/compravenda"
	"strconv"
)

func LeEntradas (args []string){
	
	for i := range args {
		
		switch(args[i]){
			case "-p": LeArquivoProdutos(args[i+1])
			case "-v": LeArquivoVendas(args[i+1])
		}

	}
}

func LeArquivoVendas (filename string){
	file, err := os.Open(filename)
	
	produtos := *compravenda.GetProdutos()
	
	if err != nil {
		log.Fatal(err)
	}
	
	defer file.Close()
	
	vendas := make(map[int]*compravenda.Venda)
	
	scanner := bufio.NewScanner(file)
	for i := 0 ; scanner.Scan() ; i++ {
		
		// Le a proxima linha
	 	line := scanner.Text()
	 	
	 	// Separa os tokens delimitados por ;
	 	tokens := strings.Split(line,";")
	 	
	 	if i != 0 {
	 		codigoProduto , _ := strconv.Atoi(tokens[2])
		 	quantidade , _ := strconv.Atoi(tokens[3])
		 	meioDePG := compravenda.ParseMeioDePagamento(tokens[4])
		 	
		 	produto := produtos[codigoProduto]
		 	
		 	//fmt.Println(produto)
		 	
		 	// Cria nova venda
		 	v := compravenda.NewVenda(meioDePG,produto,quantidade)
		 	
		 	//fmt.Println(v)
		 	
		 	// Adiciona no mapa de vendas
		 	vendas[v.GetID()] = v
		 }
	 	
	 }
	 
	 if err := scanner.Err(); err != nil {
	 	log.Fatal(err)
	 }

	/*for k := range vendas {
		fmt.Println(vendas[k])
	}*/
	
	compravenda.SetVendas(&vendas)
	//return vendas
}

func LeArquivoProdutos (filename string){
	file, err := os.Open(filename)
	
	if err != nil {
		log.Fatal(err)
	}
	
	defer file.Close()
	
	produtos := make(map[int]*compravenda.Produto)
	
	scanner := bufio.NewScanner(file)
	for i := 0 ; scanner.Scan() ; i++ {
		
		// Le a proxima linha
	 	line := scanner.Text()
	 	
	 	// Separa os tokens delimitados por ;
	 	tokens := strings.Split(line,";")
	 	
	 	if i != 0 {
		 	// Atribui tokens a campos correspondentes e converte
		 	codigo , _ := strconv.Atoi(tokens[0])
		 	desc := tokens[1]
		 	custo , _ := strconv.ParseFloat(tokens[4],64)
		 	percentual , _ := strconv.ParseFloat(tokens[5],64)
		 	
		 	// Cria novo produto
		 	p := compravenda.NewProduto(codigo,desc,custo,percentual)
		 	
		 	// Adiciona no mapa de produtos
		 	produtos[codigo] = p
		 }
	 	
	 }
	 
	 if err := scanner.Err(); err != nil {
	 	log.Fatal(err)
	 }

	/*for k := range produtos {
		fmt.Println(produtos[k])
	}*/
	
	compravenda.SetProdutos(&produtos)
	//return produtos
}

