package compravenda

type MeioDePagamento int

const(
	CHEQUE MeioDePagamento = iota
	FIADO
	CREDITO
	DEBITO
	DINHEIRO
	TICKET
)

func ParseMeioDePagamento (toParse string) MeioDePagamento{
	
	switch toParse{
		case "X" : return CHEQUE
		case "F" : return FIADO
		case "C" : return CREDITO
		case "D" : return DEBITO
		case "$" : return DINHEIRO
		case "T" : return TICKET
	}
	
	return 0
}

func (mpg MeioDePagamento) String () string {
	switch mpg{
		case CHEQUE : return "X"
		case FIADO : return "F"
		case CREDITO : return "C"
		case DEBITO : return "D"
		case DINHEIRO : return "$"
		case TICKET : return "T"
	}
	
	return "_"
}

func AllMeiosDePagamento() []MeioDePagamento {
	return []MeioDePagamento{CHEQUE,FIADO,CREDITO,DEBITO,DINHEIRO,TICKET}
}

func (mpg MeioDePagamento) Menor(c Comparavel) bool {
	if v , ehMeio := c.(MeioDePagamento) ; ehMeio {
		return mpg.String() < v.String()
	}
	
	return false
}