package compravenda

import (
	"fmt"
)

var mapaDeProdutos *map[int]*Produto

type Produto struct {
	codigo int
	descricao string
	valorDeCusto float64
	percentualDeLucro float64
}

func NewProduto (codigo int, descricao string, valorDeCusto, percentualDeLucro float64) *Produto{
	return &Produto{codigo: codigo, descricao: descricao, valorDeCusto: valorDeCusto, percentualDeLucro: percentualDeLucro}
}

func (p Produto) getPreco() float64{
	return p.valorDeCusto + p.valorDeCusto*p.percentualDeLucro/100.0
}

func (p Produto) getLucro() float64{
	return p.valorDeCusto*p.percentualDeLucro/100.0
}

func (p Produto) calculaBrutoELucroProduto (quantidade float64) (valorBruta,lucro float64) {
	
	bruto := quantidade*p.getPreco()
	custo := quantidade*p.valorDeCusto
	
	return bruto , bruto - custo
}

func (p Produto) String () string{
	return fmt.Sprintf("%d;%s;_;_;%.2f;%.2f",p.codigo,p.descricao,p.valorDeCusto,p.percentualDeLucro)
}

func (p Produto) getCodigo () int {
	return p.codigo
}

func (p Produto) getDescricao() string {
	return p.descricao
}

func (p Produto) Menor(c Comparavel) bool {
	if v , ehProduto := c.(Produto) ; ehProduto {
		return p.codigo < v.codigo
	}
	
	return false
}

func GetProdutos() *map[int]*Produto {
	return mapaDeProdutos
}

func SetProdutos(produtos *map[int]*Produto) {
	mapaDeProdutos = produtos
} 


