package compravenda

import (
	"sort"
	"math"
)

type OrdenaPorLucroECodigo []*BrutoELucro

func (o OrdenaPorLucroECodigo) Len() int {
	return len(o)
}

func(o OrdenaPorLucroECodigo) Swap(i, j int) {
	o[i] , o[j] = o[j] , o[i]
}

func (o OrdenaPorLucroECodigo) Less(i, j int) bool {
    if math.Abs(o[i].Lucro - o[j].Lucro) < 0.01 {
    	return o[i].item.Menor(o[j].item)
    }else{
    	return o[i].Lucro > o[j].Lucro
    }
}

func GeraListaOrdenadaProdutos (mapa map[int]*BrutoELucro) []*BrutoELucro{
	capacidade := len(mapa)
	
	lista := make([]*BrutoELucro,capacidade)
	
	i := 0
	
	for k := range mapa {
		lista[i] = mapa[k]
		i++	
	}
	
	sort.Sort( OrdenaPorLucroECodigo(lista) )
	
	return []*BrutoELucro(lista)
}

func GeraListaOrdenadaMeiosDePagamento (mapa map[MeioDePagamento]*BrutoELucro) []*BrutoELucro{
	capacidade := len(mapa)
	
	lista := make([]*BrutoELucro,capacidade)
	
	i := 0
	
	for k := range mapa {
		lista[i] = mapa[k]
		i++	
	}
	
	sort.Sort( OrdenaPorLucroECodigo(lista) )
	
	return []*BrutoELucro(lista)
}

